"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RpcMethodHandler = exports.RpcHandler = exports.RpcMethod = exports.RpcVersion = exports.RpcId = exports.RpcPayload = exports.RpcMethodMetadataKey = exports.RpcMetadataKey = void 0;
const common_1 = require("@nestjs/common");
exports.RpcMetadataKey = '__rpc-metadata__';
exports.RpcMethodMetadataKey = '__rpc-method-metadata__';
exports.RpcPayload = (0, common_1.createParamDecorator)((data, ctx) => {
    const req = ctx.switchToHttp().getRequest();
    return req.body.params;
});
exports.RpcId = (0, common_1.createParamDecorator)((data, ctx) => {
    const req = ctx.switchToHttp().getRequest();
    return req.body.id || null;
});
exports.RpcVersion = (0, common_1.createParamDecorator)((data, ctx) => {
    const req = ctx.switchToHttp().getRequest();
    return req.body.jsonrpc;
});
exports.RpcMethod = (0, common_1.createParamDecorator)((data, ctx) => {
    const req = ctx.switchToHttp().getRequest();
    return req.body.method;
});
const RpcHandler = (data) => {
    const scope = data ? data.scope : undefined;
    const method = data ? data.method : '';
    return (0, common_1.applyDecorators)((0, common_1.SetMetadata)(exports.RpcMetadataKey, { method }), (0, common_1.Injectable)({ scope }));
};
exports.RpcHandler = RpcHandler;
const RpcMethodHandler = (name) => {
    return (0, common_1.applyDecorators)((0, common_1.SetMetadata)(exports.RpcMethodMetadataKey, { name }));
};
exports.RpcMethodHandler = RpcMethodHandler;
