"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonRpcExplorer = void 0;
const decorators_1 = require("./context/decorators");
const core_1 = require("@nestjs/core");
const shared_utils_1 = require("@nestjs/common/utils/shared.utils");
const common_1 = require("@nestjs/common");
let JsonRpcExplorer = class JsonRpcExplorer {
    constructor(nestDiscovery) {
        this.nestDiscovery = nestDiscovery;
        this.metadataScanner = new core_1.MetadataScanner();
        this.defaultSingleMethod = 'invoke';
    }
    explore(module) {
        return this.nestDiscovery
            .getProviders({}, [module])
            .reduce((acc, instanceWrapper) => {
            const methods = this.filterHandlers(instanceWrapper);
            return [...acc, ...methods ? methods : []];
        }, []);
    }
    filterHandlers(instanceWrapper) {
        const { instance } = instanceWrapper;
        if (!instance) {
            return;
        }
        const metadata = Reflect.getMetadata(decorators_1.RpcMetadataKey, instance.constructor);
        if (metadata === undefined) {
            return;
        }
        const instancePrototype = Object.getPrototypeOf(instanceWrapper.instance);
        if (instance[this.defaultSingleMethod]) {
            return [
                {
                    callback: instance.invoke,
                    methodName: this.defaultSingleMethod,
                    instanceWrapper,
                    rpcMethodName: metadata.method,
                },
            ];
        }
        return this.metadataScanner.scanFromPrototype(instance, instancePrototype, method => {
            const { rpcMethodMetadata, callback } = this.exploreMethodHandlers(method, instancePrototype);
            const rpcMethodName = metadata.method.length === 0
                ? rpcMethodMetadata.name
                : `${metadata.method}.${rpcMethodMetadata.name}`;
            return {
                callback,
                methodName: method,
                instanceWrapper,
                rpcMethodName,
            };
        });
    }
    exploreMethodHandlers(method, instancePrototype) {
        const callback = instancePrototype[method];
        const rpcMethodMetadata = Reflect.getMetadata(decorators_1.RpcMethodMetadataKey, callback);
        if ((0, shared_utils_1.isUndefined)(rpcMethodMetadata)) {
            return null;
        }
        return {
            callback,
            rpcMethodMetadata,
        };
    }
};
exports.JsonRpcExplorer = JsonRpcExplorer;
exports.JsonRpcExplorer = JsonRpcExplorer = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.DiscoveryService])
], JsonRpcExplorer);
