import { DynamicModule, OnModuleInit } from '@nestjs/common';
import { ApplicationConfig, HttpAdapterHost, ModuleRef } from '@nestjs/core';
import { JsonRpcServer } from './json-rpc-server';
import { JsonRpcConfig, JsonRpcModuleAsyncOptions } from './index';
import { JsonRpcExplorer } from './json-rpc-explorer';
export declare const JSON_RPC_OPTIONS = "__JSON_RPC_OPTIONS__";
export declare class JsonRpcModule implements OnModuleInit {
    private rpcServer;
    private config;
    private moduleRef;
    private nestConfig;
    private httpAdapterHost;
    private jsonRpcExplorer;
    constructor(rpcServer: JsonRpcServer, config: JsonRpcConfig, moduleRef: ModuleRef, nestConfig: ApplicationConfig, httpAdapterHost: HttpAdapterHost, jsonRpcExplorer: JsonRpcExplorer);
    static forRoot(config: JsonRpcConfig): DynamicModule;
    static forRootAsync(options: JsonRpcModuleAsyncOptions): DynamicModule;
    private static createAsyncProvider;
    private static createAsyncOptionsProvider;
    onModuleInit(): Promise<void>;
}
