"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var JsonRpcModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonRpcModule = exports.JSON_RPC_OPTIONS = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const json_rpc_server_1 = require("./json-rpc-server");
const rpc_routes_resolver_1 = require("./rpc-routes-resolver");
const json_rpc_explorer_1 = require("./json-rpc-explorer");
exports.JSON_RPC_OPTIONS = '__JSON_RPC_OPTIONS__';
let JsonRpcModule = JsonRpcModule_1 = class JsonRpcModule {
    constructor(rpcServer, config, moduleRef, nestConfig, httpAdapterHost, jsonRpcExplorer) {
        this.rpcServer = rpcServer;
        this.config = config;
        this.moduleRef = moduleRef;
        this.nestConfig = nestConfig;
        this.httpAdapterHost = httpAdapterHost;
        this.jsonRpcExplorer = jsonRpcExplorer;
    }
    static forRoot(config) {
        return {
            module: JsonRpcModule_1,
            imports: [core_1.DiscoveryModule],
            providers: [
                {
                    provide: exports.JSON_RPC_OPTIONS,
                    useValue: config,
                },
                json_rpc_server_1.JsonRpcServer,
                json_rpc_explorer_1.JsonRpcExplorer,
            ],
            exports: [
                {
                    provide: exports.JSON_RPC_OPTIONS,
                    useValue: config,
                },
            ],
            controllers: [],
        };
    }
    static forRootAsync(options) {
        return {
            module: JsonRpcModule_1,
            imports: [...(options.imports || []), core_1.DiscoveryModule],
            providers: [
                json_rpc_server_1.JsonRpcServer,
                json_rpc_explorer_1.JsonRpcExplorer,
                ...this.createAsyncProvider(options),
            ],
            exports: [...this.createAsyncProvider(options)],
        };
    }
    static createAsyncProvider(options) {
        if (options.useExisting || options.useFactory) {
            return [this.createAsyncOptionsProvider(options)];
        }
        return [
            this.createAsyncOptionsProvider(options),
            {
                provide: options.useClass,
                useClass: options.useClass,
            },
        ];
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                provide: exports.JSON_RPC_OPTIONS,
                useFactory: options.useFactory,
                inject: options.inject || [],
            };
        }
        return {
            provide: exports.JSON_RPC_OPTIONS,
            useFactory: (optionsFactory) => __awaiter(this, void 0, void 0, function* () { return yield optionsFactory.createJsonRpcOptions(); }),
            inject: [options.useExisting || options.useClass],
        };
    }
    onModuleInit() {
        return __awaiter(this, void 0, void 0, function* () {
            const { container, injector } = this.moduleRef;
            const routesResolver = new rpc_routes_resolver_1.RpcRoutesResolver(container, this.nestConfig, injector, this.config, this.jsonRpcExplorer);
            const prefix = this.nestConfig.getGlobalPrefix();
            const rpcHandlers = routesResolver.resolve(this.httpAdapterHost.httpAdapter, prefix);
            this.rpcServer.run(rpcHandlers, this.config);
        });
    }
};
exports.JsonRpcModule = JsonRpcModule;
exports.JsonRpcModule = JsonRpcModule = JsonRpcModule_1 = __decorate([
    (0, common_1.Module)({}),
    __param(1, (0, common_1.Inject)(exports.JSON_RPC_OPTIONS)),
    __metadata("design:paramtypes", [json_rpc_server_1.JsonRpcServer, Object, core_1.ModuleRef,
        core_1.ApplicationConfig,
        core_1.HttpAdapterHost,
        json_rpc_explorer_1.JsonRpcExplorer])
], JsonRpcModule);
