import { RpcMethodHandler } from './interfaces';
import { InstanceWrapper } from '@nestjs/core/injector/instance-wrapper';
import { Module } from '@nestjs/core/injector/module';
import { ApplicationConfig, NestContainer } from '@nestjs/core';
import { Injector } from '@nestjs/core/injector/injector';
import { ProxyCallback } from './types';
export declare class RpcCallbackProxy {
    private readonly config;
    private readonly container;
    private readonly injector;
    private readonly routerProxy;
    private readonly exceptionFiltersCache;
    private readonly executionContextCreator;
    private readonly exceptionsFilter;
    constructor(config: ApplicationConfig, container: NestContainer, injector: Injector);
    create(rpcMethodHandler: RpcMethodHandler, moduleKey: string): ProxyCallback | (<TRequest extends Record<any, any>, TResponse>(req: TRequest, res: TResponse, next: () => void) => Promise<unknown>);
    private createCallbackProxy;
    createRequestScopedHandler(instanceWrapper: InstanceWrapper, moduleRef: Module, moduleKey: string, methodName: string): <TRequest extends Record<any, any>, TResponse>(req: TRequest, res: TResponse, next: () => void) => Promise<unknown>;
    private getContextId;
}
