import { HttpServer } from '@nestjs/common/interfaces';
import { Resolver } from '@nestjs/core/router/interfaces/resolver.interface';
import { ApplicationConfig, NestContainer } from '@nestjs/core';
import { Injector } from '@nestjs/core/injector/injector';
import { JsonRpcConfig, RpcMethodHandler } from './interfaces';
import { JsonRpcExplorer } from './json-rpc-explorer';
import { RouterProxyCallback } from '@nestjs/core/router/router-proxy';
import { ProxyCallback } from './types';
export declare const RPC_MAPPING_MESSAGE: (name: string, path: string, method: string) => string;
export interface RpcProxyHandler {
    proxy: ProxyCallback;
    method: string;
}
export declare class RpcRoutesResolver implements Resolver {
    private readonly container;
    private readonly config;
    private readonly injector;
    private readonly rpcConfig;
    private readonly jsonRpcExplorer;
    private readonly logger;
    private rpcCallbackProxy;
    constructor(container: NestContainer, config: ApplicationConfig, injector: Injector, rpcConfig: JsonRpcConfig, jsonRpcExplorer: JsonRpcExplorer);
    resolve<T extends HttpServer>(applicationRef: T, basePath: string): Map<string, RouterProxyCallback>;
    registerRouters(routes: RpcMethodHandler[], moduleKey: string, basePath: string): RpcProxyHandler[];
    registerNotFoundHandler(): void;
    registerExceptionHandler(): void;
    private getModulePathMetadata;
}
